unit FCounters;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls, Grids, Menus;

type
  TCounters = class(TForm)
    sg: TStringGrid;
    cntPop: TPopupMenu;
    cntCopyInfoText: TMenuItem;
    N1: TMenuItem;
    cntSaveReplayBtn: TMenuItem;
    cntSaveBoardBtn: TMenuItem;
    cntPreviewReplayBtn: TMenuItem;

    procedure FormCreate(Sender: TObject);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure sgMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure sgMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure cntSaveReplayBtnClick(Sender: TObject);
    procedure cntSaveBoardBtnClick(Sender: TObject);
    procedure cntCopyInfoTextClick(Sender: TObject);
    procedure cntPreviewReplayBtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Counters: TCounters;
  isDown:boolean=false;
  cPos:tpoint;
	
implementation

uses FData,FFunc, FMain,FCap;
{$R *.DFM}

procedure TCounters.FormCreate(Sender: TObject);
begin
counters_form_created:=true;
counters.sg.Top:=2;
counters.sg.Left:=2;

{counters.sg.ColWidths[0]:=opt.widthCr1;
counters.sg.ColWidths[1]:=opt.widthCr2;
counters.ClientWidth:=counters.sg.ColWidths[0]+counters.sg.ColWidths[1]+1+4;
counters.sg.Width:=counters.sg.ColWidths[0]+counters.sg.ColWidths[1]+1;
counters.sg.Width:=counters.sg.GridWidth;
counters.ClientWidth:=counters.sg.Width+4; }

//reload_other_options;
counters.left:=opt.posCountersx;
counters.top:=opt.posCountersy;
if counters.Left<0 then counters.left:=0;
if counters.Left>screen.width-counters.width then
   counters.Left:=screen.width-counters.width;
if counters.top<0 then counters.top:=0;
if counters.top>screen.height-counters.height then
   counters.top:=screen.height-counters.height;
//if opt.doShowCounters then counters_show else counters_hide;
//clear_counters;
counters.Color:=clBtnFace;

{counters.cntSaveReplayBtn.enabled:=false;
counters.cntSaveBoardBtn.enabled:=false;
counters.cntPreviewReplayBtn.Enabled:=false; }

//language_apply;
counters.caption:=cap_counters_caption;
{
counters.lL.Caption:=cap_lL;
counters.lR.Caption:=cap_lR;
counters.lD.Caption:=cap_lD;
counters.l3bv.Caption:=cap_l3bv;
counters.ldone.Caption:=cap_done;
counters.l3bvs.Caption:=cap_l3bvs;
counters.lTime.Caption:=cap_lTime;   }

counters.cntSaveBoardBtn.caption:=cap_main_SaveBoard;
counters.cntSaveReplayBtn.Caption:=cap_sbSavereplay;
counters.cntCopyInfoText.Caption:=cap_cntCopyInfoText;
counters.cntPreviewReplayBtn.Caption:=cap_cntPreviewReplayBtn;
//if opt.doShowCounters then showwindow(counters.handle,sw_showNA);
if opt.doShowCounters then counters_show else counters_hide;
end;

procedure TCounters.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  myRect: TGridRect;
begin
  myRect.Left:=0;
  myRect.Top:=0;
  myRect.Right:=1;
  myRect.Bottom:=0;
  sg.Selection:=myRect;
ActiveControl:=nil;

{if button=mbRight then begin
   opt.doShowCountersTitle:=not opt.doShowCountersTitle;
   counters_show;
   isDown:=false;
   exit;end;  }
isDown:=true;
//saving theme's width
cPos:=point(x,y-((width-clientwidth) div 2));
end;

procedure TCounters.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
if isDown then
if borderstyle=bssingle then
   begin
   counters.Left:=mouse.CursorPos.x-
      (cPos.x+trunc((width-clientwidth)/2));
   counters.Top:=mouse.CursorPos.y-
      (cPos.y+(height-clientheight));
   end
   else begin
   counters.Top:=mouse.CursorPos.y-cPos.y;
   counters.Left:=mouse.CursorPos.x-cPos.x;
   end;
end;

procedure TCounters.FormMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var myRect:tgridrect;
begin
  myRect.Left:=0;
  myRect.Top:=0;
  myRect.Right:=1;
  myRect.Bottom:=0;
  sg.Selection:=myRect;
ActiveControl:=nil;
//showwindow(counters.handle,sw_showNA);
//showwindow(main.handle,SW_SHOWNORMAL);
main.BringToFront;
isDown:=false;
if not main.Enabled then exit;
if (abs(top+height-main.top)<25)then top:=main.top-height;
if (abs(top-main.top)<25)then top:=main.top;
if (abs(left-(main.left+main.width-width))<25)then left:=main.left+main.width-width;
if (abs(left-(main.left+main.width))<25)then left:=main.left+main.width;
if (abs(left-(main.left-width))<25)then left:=main.left-width;
if (abs(left-(main.left))<25)then left:=main.left;
end;

procedure TCounters.sgMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var
  myRect: TGridRect;
begin
  myRect.Left:=0;
  myRect.Top:=0;
  myRect.Right:=1;
  myRect.Bottom:=0;
  sg.Selection:=myRect;
ActiveControl:=nil;

if isDown then
if borderstyle=bssingle then
   begin
   counters.Left:=mouse.CursorPos.x-
      (cPos.x+trunc((width-clientwidth)/2))+
      sg.Left;
   counters.Top:=mouse.CursorPos.y-
      (cPos.y+(height-clientheight))+
      sg.top;
   end
   else begin
   counters.Top:=mouse.CursorPos.y-cPos.y+sg.top;
   counters.Left:=mouse.CursorPos.x-cPos.x+sg.Left;
   end;
end;

procedure TCounters.sgMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  myRect: TGridRect;
begin
  myRect.Left:=0;
  myRect.Top:=0;
  myRect.Right:=1;
  myRect.Bottom:=0;
  sg.Selection:=myRect;
ActiveControl:=nil;

if button=mbRight then
   begin
   isDown:=false;
   cntPop.Popup(mouse.cursorpos.x,mouse.cursorpos.y);
   exit;end;


{if button=mbRight then begin
   opt.doShowCountersTitle:=not opt.doShowCountersTitle;
   counters_show;
   isDown:=false;
   exit;end;}

isDown:=true;
//saving theme's width
if opt.doShowCountersTitle then
   cPos:=point(x+4,y+(trunc((width-clientwidth)/2)-sg.top))
   else cPos:=point(x+4,y+4);

end;

procedure TCounters.cntSaveReplayBtnClick(Sender: TObject);
begin
main.BringToFront;
main.sbSavereplay.Click;
end;

procedure TCounters.cntSaveBoardBtnClick(Sender: TObject);
begin
main.BringToFront;
main.btnSaveBoard.Click;
end;

procedure TCounters.cntCopyInfoTextClick(Sender: TObject);
var
  s,sEx,sMode:string;
  i:integer;
  cn1,cn2:byte;
begin main.BringToFront;
//mirc,cgi,text
sEx:=uppercase(opt.ircCntExclude);
case mode of
0:sMode:='beg';
1:sMode:='int';
2:sMode:='exp';
3:sMode:='custom';
end;
case opt.doirctype of
2:begin//text
s:=ircoutputmode+' ';
if is_replay_mode then s:=s+randomwatched+' ';
//if done<>bbbv then s:=s+randomblasted+' ';
s:=s+sMode+' game --> ';
for i:=0 to counters.sg.RowCount-1 do
   if (not is_replay_mode)or((is_replay_mode)and(pos(uppercase(counters.sg.cells[0,i]),'RANK')<1)
      and(pos(uppercase(counters.sg.cells[0,i]),'RPI')<1))then
   if (not opt.doCntExclude )or(
   ((pos(uppercase(counters.sg.cells[0,i])+'\N',sEx)<1))and(opt.doCntExclude)) then

   s:=s+''+counters.sg.cells[0,i]+': '+counters.sg.cells[1,i]+'  ';
delete(s,length(s)-3,4);
if is_replay_mode then s:=s+'- '+main.lNameLabel.caption;
if random(2)=0 then s:=s+' '+randomsmile;
end;
//--------------------------------------------------------------
0:begin//mirc
cn1:=0;
cn2:=0;
case opt.irccolor1 of
0: cn1:=random(15)+1;
1..15:cn1:=opt.irccolor1;
end;
case opt.irccolor2 of
0: cn2:=random(15)+1;
1..15:cn2:=opt.irccolor2;
end;

if opt.irccolor1+opt.irccolor1=0 then
while (cn1=cn2)or(cn1=8)or(cn1=9)or(cn1=11)or(cn1=12)or(cn1=13)
or(cn2=8)or(cn2=9)or(cn2=11)or(cn2=12)or(cn2=13)do begin
   cn1:=2+random(13);cn2:=2+random(13);end;

s:=ircoutputmode+' ';
if is_replay_mode then s:=s+irc_color_mirc(irc_bold_mirc(randomwatched),cn2)+' ';
//if done<>bbbv then s:=s+irc_color_mirc(irc_bold_mirc(randomblasted),cn2)+' ';
s:=s+irc_color_mirc('last',cn1)+' '+irc_color_mirc(irc_bold_mirc(sMode),cn2)+' '+
   irc_color_mirc('game',cn1)+' '+irc_color_mirc(irc_bold_mirc('-->'),cn2)+' ';
for i:=0 to counters.sg.RowCount-1 do
   if (not is_replay_mode)or((is_replay_mode)and(pos(uppercase(counters.sg.cells[0,i]),'RANK')<1)
      and(pos(uppercase(counters.sg.cells[0,i]),'RPI')<1))then
   if (not opt.doCntExclude )or(
   ((pos(uppercase(counters.sg.cells[0,i])+'\N',sEx)<1))and(opt.doCntExclude)) then
   s:=s+
   irc_color_mirc(counters.sg.cells[0,i]+'=',cn1)+
   ''+
   irc_color_mirc(irc_bold_mirc(counters.sg.cells[1,i]),cn2)+
   ' ';
if is_replay_mode then s:=s+irc_color_mirc('- ',cn1)+irc_color_mirc(main.lNameLabel.caption,cn2);
if random(2)=0 then s:=s+' '+irc_color_mirc(irc_bold_mirc(randomsmile),cn2);
end;
//--------------------------------------------------------------
1:begin//cgi
cn1:=0;
cn2:=0;
case opt.irccolor1 of
0: cn1:=random(15)+1;
1..15:cn1:=opt.irccolor1;
end;
case opt.irccolor2 of
0: cn2:=random(15)+1;
1..15:cn2:=opt.irccolor2;
end;

if opt.irccolor1+opt.irccolor1=0 then
while (cn1=cn2)or(cn1=8)or(cn1=9)or(cn1=11)or(cn1=12)or(cn1=13)
or(cn2=8)or(cn2=9)or(cn2=11)or(cn2=12)or(cn2=13)do begin
   cn1:=2+random(13);cn2:=2+random(13);end;

s:=ircoutputmode+' ';
if is_replay_mode then s:=s+irc_color_cgi(irc_bold_cgi(randomwatched),cn2)+' ';
//if done<>bbbv then s:=s+irc_color_cgi(irc_bold_cgi(randomblasted),cn2)+' ';
s:=s+irc_color_cgi('last',cn1)+' '+irc_color_cgi(irc_bold_cgi(sMode),cn2)+' '+
   irc_color_cgi('game',cn1)+' '+irc_color_cgi(irc_bold_cgi('-->'),cn2)+' ';
for i:=0 to counters.sg.RowCount-1 do
   if (not is_replay_mode)or((is_replay_mode)and(pos(uppercase(counters.sg.cells[0,i]),'RANK')<1)
      and(pos(uppercase(counters.sg.cells[0,i]),'RPI')<1))then
   if (not opt.doCntExclude )or(
   ((pos(uppercase(counters.sg.cells[0,i])+'\N',sEx)<1))and(opt.doCntExclude)) then
   s:=s+
   irc_color_cgi(counters.sg.cells[0,i]+'=',cn1)+
   ''+
   irc_color_cgi(irc_bold_cgi(counters.sg.cells[1,i]),cn2)+
   ' ';
if is_replay_mode then s:=s+irc_color_cgi('- ',cn1)+irc_color_cgi(main.lNameLabel.caption,cn2);
if random(2)=0 then s:=s+' '+irc_color_cgi(irc_bold_cgi(randomsmile),cn2);
end;
//--------------------------------------------------------------
end;//case

if(isCheatMode) then s:=s+' (cheat mode) ';
//if(isNCMode) then s:=s+' (custom mode '+inttostr(dx+1)+' '+inttostr(dy+1)+' '+inttostr(mc)+') ';

StrToClipbrd(s);
end;

procedure TCounters.cntPreviewReplayBtnClick(Sender: TObject);
begin
main.BringToFront;
main.btnPreviewReplay.Click;
end;

end.
