unit FMath;
{$N+}
interface uses Math,SysUtils,Controls,Dialogs;

const MaxDeep=255;      // cycle detection

type  TSCVariables=array['A'..'Z'] of Extended;   //vars

var   Variables:TSCVariables;
      raised:boolean=false;//is_error_occured
      mdeep:word=0;

function CalcStr(const S:string):Extended; //global

implementation
uses fmain,ffunc,fdata,fdebug;
{-----------------------------------------------------------------------}
function AddEnd(const S:string;var P:Integer;deep:word):Extended;forward;
function Multiplier(const S:string;var P:Integer;deep:word):Extended;forward;
function Func(const S:string;var P:Integer;deep:word):Extended;forward;
{-----------------------------------------------------------------------}
function Expr(const S:string;var P:Integer;deep:word):Extended;//main eval func
begin
	if raised then begin result:=0;
	if debug_show_math_module_errors then
		debug_add('#counters_formula_error handled: closing stack');exit;end;

	if (s='')or(s=' ')or(s='0')or(s='0=')then begin 
		result:=0;
		exit;
	end;
	// cycle detection
	deep:=deep+1;

	if debugmode then
		if mdeep<deep then begin
			mdeep:=deep;
			debug_add('math_max_deep = '+inttostr(mdeep));
			end;
    
	if deep>MAXDEEP then begin
		result:=0;
		if debug_show_math_module_errors then
		debug_add('#counters_formula_error: 1000 iterations done. cycle detected. pos='+inttostr(p-1));
		raised:=true;
		exit;
		end;

	//no cycle ->
	Result:=Addend(S,P,deep);//defining right part of expression
	while S[P] in ['+','-'] do
		case S[P] of
		'+':begin
			Inc(P);
			Result:=Result+Addend(S,P,deep)
			end;
		'-':begin
			Inc(P);
			Result:=Result-Addend(S,P,deep)
			end;
		end;
end;
{---------------------------------------------------------------------}
function Addend; // dodanok
var t:extended;
begin
	if raised then begin result:=0;
	if debug_show_math_module_errors then
		debug_add('#counters_formula_error handled: closing stack');exit;end;

	Result:=Multiplier(S,P,deep);
	while S[P] in ['*','/'] do begin
	case S[P] of
		'*':begin
				Inc(P);
				Result:=Result*Multiplier(S,P,deep)
			end;
		'/':begin
				Inc(P);
				t:=Multiplier(S,P,deep);
				if t=0 then begin
					result:=0;
					if debug_show_math_module_errors then
						debug_add('#counters_formula_error: division by 0. pos='+inttostr(p-1));
					raised:=true;
					exit;
				end;
				Result:=Result/t;
			end;
		end;
	end;
end;
{---------------------------------------------------------------------}
function Multiplier; //mnozhnik
var J,D:Integer;
begin
if raised then begin result:=0;
if debug_show_math_module_errors then
   debug_add('#counters_formula_error handled: closing stack');exit;end;

case UpCase(S[P]) of            // type analyse
      '0'..'9':begin                           // number
                Val(Copy(S,P,MaxInt),{d}Result,J); // this is an error
                j:=j+trunc(result*0);// debugger hook
                Val(Copy(S,P,J-1),Result,D);       // so j=first illegal char
                P:=P+J-1
               end;
      '-':begin                                  //   prefix
           Inc(P);
           Result:=-Multiplier(S,P,deep)
          end;
      '[':begin                                  //   truncation
           Inc(P);
           Result:=Expr(S,P,deep);
           if Result>=0 then
            Result:=Int(Result)
           else
            Result:=Int(Result)-1;
           if S[P]=']' then    // close brace
            Inc(P)
           else
                      begin
                      result:=0;
                      if debug_show_math_module_errors then
                      debug_add('#counters_formula_error: waiting '']''. pos='+inttostr(p-1));
                      raised:=true;
                      exit;
                      end;

          end;
      '(':begin                                  // change procedures priority
           Inc(P);
           Result:=Expr(S,P,deep);
           if S[P]=')' then                      //  closing br
            Inc(P)
           else
                      begin
                      result:=0;
                      if debug_show_math_module_errors then
                      debug_add('#counters_formula_error: waiting '')''. pos='+inttostr(p-1));
                      raised:=true;
                      exit;
                      end;
          end;
      'A'..'Z':Result:=Func(S,P,deep)                //  -> func or var
      else
                      begin
                      result:=0;
                      if debug_show_math_module_errors then
                      debug_add('#counters_formula_error: illegal character "'+S[P]+'". pos='+inttostr(p));
                      raised:=true;
                      exit;
                      end;

     end
    end;
{---------------------------------------------------------------------}
{  function BoolExpr(const S:string;var P:Integer;deep:word):Boolean;
   var A,B,C:Extended;
       T,T2:Byte;
    begin
     A:=Expr(S,P,deep);
     if P=Length(S) then
      raise Err.Create(se+'UNEXPECTED END OF EXPRESSION');
     case S[P] of
      '=':T:=1;
      '>':if S[P+1]='=' then
           begin
            T:=2;
            Inc(P)
           end
          else
           T:=3;
      '<':begin
           Inc(P);
           case S[P] of
            '=':T:=4;
            '>':T:=5
           else
            begin
             Dec(P);
             T:=6
            end
           end
          end
     else
       raise Err.Create(se+'ILLEGAL CHARACTER "'+S[P]+'" IN POSITION #'+IntToStr(P))
     end;
     Inc(P);
     B:=Expr(S,P,deep);
     BoolExpr:=False;
     if (T in [4,6]) and (S[P]='<') then
      begin
       if S[P+1]='=' then
        begin
         Inc(P);
         T2:=6
        end
       else
        T2:=4;
       Inc(P);
       C:=Expr(S,P,deep);
       case T+10*T2 of
        44:if (A<=B) and (B<=C) then
            BoolExpr:=True;
        46:if (A<B) and (B<=C) then
            BoolExpr:=True;
        64:if (A<=B) and (B<C) then
            BoolExpr:=True;
        66:if (A<=B) and (B<=C) then
            BoolExpr:=True
       end
      end
     else
      case T of
       1:if A=B then
          BoolExpr:=True;
       2:if A>=B then
          BoolExpr:=True;
       3:if A>B then
          BoolExpr:=True;
       4:if A<=B then
          BoolExpr:=True;
       5:if A<>B then
          BoolExpr:=True;
       6:if A<B then
          BoolExpr:=True
      end
    end;}
{---------------------------------------------------------------------}
function faktorial(a:extended):extended;
var b,i:extended;
begin
if raised then begin result:=0;
   if debug_show_math_module_errors then
   debug_add('#counters_formula_error handled: closing stack');exit;end;
result:=1;
b:=trunc(a);
if b<2 then exit;
i:=1;
while i<=b do begin result:=result*i;i:=i+1;end;
end;
{---------------------------------------------------------------------}
function Func;
var
   N:string;
   D,ISN:Extended;
   I,K:LongInt;
   PO:Integer;
   tmp,tmp2,tmp3:LongInt;
   tmpS,tmpH:longInt;
   trqp:single;
   tmp47:extended;
//   Bl:Boolean;
begin
result:=0;
if raised then begin result:=0;
   if debug_show_math_module_errors then
   debug_add('#counters_formula_error handled: closing stack');exit;end;

   N:=UpCase(S[P]);
   Inc(P);
// define whole-func name:
   while UpCase(S[P]) in ['0'..'9','A'..'Z'] do
      begin
      N:=N+UpCase(S[P]);
      Inc(P)
      end;
// define N-Type of:       if we have 'n(' --> it's function

     if S[P]='(' then  // --> it is function!
     begin
     Inc(P);
       if N='INC' then   //   increase
       Func:=Expr(S,P,deep)+1
       else
       if N='DEC' then   //   decrease
       Func:=Expr(S,P,deep)-1
       else
       if N='COS' then
       Func:=Cos(Expr(S,P,deep))
       else
       if N='SQR' then
       Func:=Sqr(Expr(S,P,deep))
       else
       if N='SQRT' then
       Func:=Sqrt(Expr(S,P,deep))
       else
       if N='SIN' then
       Func:=Sin(Expr(S,P,deep))
       else
       if N='TG' then
       Func:=Tan(Expr(S,P,deep))
       else
       if N='CTG' then
       Func:=Cotan(Expr(S,P,deep))
       else
       if N='ARCCOS' then
       Func:=ArcCos(Expr(S,P,deep))
       else
       if N='ARCSIN' then
       Func:=ArcSin(Expr(S,P,deep))
       else
       if N='ARCTG' then
       Func:=ArcTan(Expr(S,P,deep))
       else
       if N='EXP' then
       Func:=Exp(Expr(S,P,deep))

       else              //check the input values
       if N='LN' then
       Func:=Ln(Expr(S,P,deep))
       else
       if N='LG' then
       Func:=Log10(Expr(S,P,deep))
       else
       if N='LOG' then   //  log(a,b)
          begin
          D:=Expr(S,P,deep);
          if S[P]<>',' then
                      begin
                      result:=0;
                      if debug_show_math_module_errors then
                      debug_add('#counters_formula_error: waiting '',''. pos='+inttostr(p));
                      raised:=true;
                      exit;
                      end;

          Inc(P);
          Func:=LogN(D,Expr(S,P,deep))
          end

       else
       if N='POWER' then   //   ^
          begin
          D:=Expr(S,P,deep);
          if S[P]<>',' then

                      begin
                      result:=0;
                      if debug_show_math_module_errors then
                      debug_add('#counters_formula_error: waiting '',''. pos='+inttostr(p));
                      raised:=true;
                      exit;
                      end;

          Inc(P);
          Func:=Power(D,Expr(S,P,deep))
          end

       else
       if N='FAKT' then
       Func:=faktorial(Expr(S,P,deep))

       else
{       if N='ABS' then
       Func:=Abs(Expr(S,P,deep))
       else
       if N='SH' then
       Func:=SinH(Expr(S,P,deep))
       else
       if N='CH' then
       Func:=CosH(Expr(S,P,deep))
       else
       if N='TH' then
       Func:=TanH(Expr(S,P,deep))
       else}
{       if N='ARCSH' then
       Func:=ArcSinH(Expr(S,P,deep))
       else
       if N='ARCCH' then
       Func:=ArcCosH(Expr(S,P,deep))
       else
       if N='ARCTH' then
       Func:=ArcTanH(Expr(S,P,deep))
       else}

       if N='SGN' then
          begin
          Result:=Expr(S,P,deep);
          if Result>0 then Result:=1
             else if Result<0 then Result:=-1
                else Result:=0
          end

       else
       if N='SUM' then  // use as  SUM(x0,xN,expression)
                        // or      SUM(x0,xN,expression(i))
          begin
          I:=Trunc(Expr(S,P,deep));
          if S[P]<>',' then

                      begin
                      result:=0;
                      if debug_show_math_module_errors then
                      debug_add('#counters_formula_error: waiting '',''. pos='+inttostr(p));
                      raised:=true;
                      exit;
                      end;

          Inc(P);
          K:=Trunc(Expr(S,P,deep));
          if S[P]<>',' then

                      begin
                      result:=0;
                      if debug_show_math_module_errors then
                      debug_add('#counters_formula_error: waiting '',''. pos='+inttostr(p));
                      raised:=true;
                      exit;
                      end;

          if I>K then
                      begin
                      result:=0;
                      if debug_show_math_module_errors then
                      debug_add('#counters_formula_error: upper bound must be larger than bottom. pos='+inttostr(p));
                      raised:=true;
                      exit;
                      end;

          ISN:=Variables['I'];    //  remember old I
          Inc(P);
          PO:=P;    //  remember index
          D:=0;
             repeat
             P:=PO;
             Variables['I']:=I;
             D:=D+Expr(S,P,deep); // calculating expression(i)
             Inc(I)
             until I>K;
          Variables['I']:=ISN;   //   awake I
          Func:=D
          end

       else
       if N='MAX' then   //   max (x1,..,xN) N>0
          begin
          D:=Expr(S,P,deep);
          while S[P]=',' do   //   ,
             begin
             Inc(P);
             ISN:=Expr(S,P,deep);
             if ISN>D then D:=ISN
             end;
          Func:=D
          end

       else
       if N='MIN' then
          begin
          D:=Expr(S,P,deep);
          while S[P]=',' do
             begin
             Inc(P);
             ISN:=Expr(S,P,deep);
             if ISN<D then D:=ISN
             end;
          Func:=D
          end

{       else
       if N='IF' then   //   use as IF(logical expression,A,B)
          begin
          Bl:=BoolExpr(S,P,deep);
          if S[P]<>',' then raise Err.Create(se+'WAITING '','' IN POSITION #'+IntToStr(P));
          Inc(P);
          D:=Expr(S,P,deep);
          if S[P]<>',' then raise Err.Create(se+'WAITING '','' IN POSITION #'+IntToStr(P));
          Inc(P);
          ISN:=Expr(S,P,deep);
          if Bl then Func:=D else Func:=ISN
          end}
       ELSE

                      begin
                      result:=0;
                      if debug_show_math_module_errors then
                      debug_add('#counters_formula_error: unknown function '+N);
                      raised:=true;
                      exit;
                      end;

       if S[P]=')' then Inc(P) // brace must be closed now
          else

                      begin
                      result:=0;
                      if debug_show_math_module_errors then
                      debug_add('#counters_formula_error: waiting '')''. pos='+inttostr(p));
                      raised:=true;
                      exit;
                      end;

       END // <-- we had 'N()'

     else
     if N='E' then Result:=Exp(1) //math          extended
     // one virtual_variable

{     if Length(N)=1 then Func:=Variables[N[1]]
     // pointer to the grid_CELL like [ A1..Z9 ]
     else
     if (Length(N)=2)
     and(UpCase(N[1]) in ['A'..'Z'])
     and(UpCase(N[2]) in ['1'..'9'])
     then
        begin
//        Func:=expr(main.sg.Cells[ord(N[1])-ord('A')+1,strtoint(N[2])],tmp,deep)
        cell:=main.sg.Cells[ord(N[1])-ord('A')+1,strtoint(N[2])];
        correct(cell);
        Func:=calcstr(cell)
        end
     // pointer to the grid_CELL like [ A10..Z99 ]
     else
     if (Length(N)=3)
     and(UpCase(N[1]) in ['A'..'Z'])
     and(UpCase(N[2]) in ['1'..'9'])
     and(UpCase(N[3]) in ['0'..'9'])
     then
        begin
//        Func:=expr(main.sg.Cells[ord(N[1])-ord('A')+1,strtoint(N[2])*10+strtoint(N[3])],tmp,deep)
        cell:=main.sg.Cells[ord(N[1])-ord('A')+1,strtoint(N[2])*10+strtoint(N[3])];
        correct(cell);
        Func:=calcstr(cell)
        end
     // other
     else}

     {if N='PI' then Result:=Pi //math
     else
     if N='INF' then Result:=strtofloat('1,1E4932') //math}

     else if N='TIME' then
        begin
			if(opt.doRecorderStyleTimer) then
				Result:=1+gTime.s+gTime.h/100
			else
				Result:=gTime.s+gTime.h/100;
			//if gTime.h=0 then Result:=Result+0.001;
        end
	 else if N='TIMEINT' then
		begin
			if(gTime.h=0) then
				Result:=gTime.s
			else
				Result:=gTime.s+1;
		end
     else if N='TIMEREAL' then
        begin
			  Result:=gTime.s+gTime.h/100;	{0.47} {we're going realtime}
				//if gTime.h=0 then Result:=Result+0.001;
        end
	 else if N='TIMERECORDERSTYLE' then
		begin
			  Result:=1+gTime.s+gTime.h/100;	{0.47} {we're going realtime} {for +1-ers}
				//if gTime.h=0 then Result:=Result+0.001;
		end
     else if N='TIMEEST' then
        begin
        result:=0;
           if (opt.doShow3BVafterGameStart)
              or(is_replay_mode)
              or(was_blasted)
              then
           if (Done<>0)and((gTime.s+gTime.h/100)<>0) then
				case opt.doRecorderStyleTimer of
				true:
					result:=(gTime.s+gTime.h/100)/(done/bbbv)+1;
				false:
					result:=(gTime.s+gTime.h/100)/(done/bbbv);
				end
           else
                result:=999.99;
        end
	 else if N='TIMEESTREAL' then
        if (Done<>0)and((gTime.s+gTime.h/100)<>0) then
            result:=(gTime.s+gTime.h/100)/(done/bbbv)
        else
            result:=999.99
	 else if N='TIMEESTINT' then
        if (Done<>0)and((gTime.s+gTime.h/100)<>0) then begin
			tmp47:=(gTime.s+gTime.h/100)/(done/bbbv);
            result:=trunc(tmp47);
			if(tmp47>result) then result:=result+1;
		end
        else
            result:=999
	 else if N='TIMEESTRECORDERSTYLE' then
        if (Done<>0)and((gTime.s+gTime.h/100)<>0) then
            result:=(gTime.s+gTime.h/100)/(done/bbbv)+1
        else
            result:=999.99
     else if N='BBBV' then
        begin
        result:=0;
           if (opt.doShow3BVafterGameStart)
              or(is_replay_mode)
              or(was_blasted)
              then
           begin
           Result:=bbbv;
           end;
        end
     else if N='BBBVS' then
        begin
                if(gTime.s+gTime.h>0) then
                        result:=trunc(done/(gTime.S+gTime.H/100))+
        						trunc(100*frac(done/(gTime.S+gTime.H/100)))/100
                else
                        result:=0;
        end
     else if N='BBBVDONE' then
        begin
        result:=0;
           if (opt.doShow3BVafterGameStart)
              or(is_replay_mode)
              or(was_blasted)
              then
           begin
           Result:=done;
           end;//case
        end
	 else if N='GZINI' then
		result:=gzini
	 else if N='HZINI' then
		result:=hzini
     else if N='IOS' then
        begin
        result:=0;
           if// (opt.doShow3BVafterGameStart)
//              or(is_replay_mode)
              //(was_blasted)
              //or
              (iswin)
              then
           begin
           if (gTime.s>9)then
           Result:=logN(gTime.s+gTime.h/100,bbbv)
              else result:=0;
           end;//case
        end
     else if N='RQP' then
        begin
        result:=0;
        if//(was_blasted)
           //or
           (iswin)
           then
           begin
             if (bbbv<>0)and(gTime.s+gTime.h<>0)then
             Result:=(gTime.s+1+gTime.h/100)/(bbbv/(gTime.s+gTime.h/100))	{0.47}
                   else result:=0;
           end;
        end
     else if N='LCLK' then
        begin
        Result:=Lcnt;
        end
     else if N='RCLK' then
        begin
        Result:=Rcnt;
        end
     else if N='CLASSICRCLK' then
        begin
        Result:=classicRcnt;
        end
     else if N='DCLK' then
        begin
        Result:=Dcnt;
        end
     else if N='TOTALCLK' then
        begin
        Result:=Lcnt+Rcnt+Dcnt;
        end
     else if N='CLASSICTOTALCLK' then
        begin
        Result:=Lcnt+classicRcnt+Dcnt;
        end
     else if N='LEFF' then
        begin
           Result:=Lecnt;
        end
     else if N='REFF' then
        begin
           Result:=Recnt;
        end
     else if N='MISFLAGS' then
        begin
        result:=Rmisflags;
        end
     else if N='UNFLAGS' then
        begin
        result:=Runflags;
        end
     else if N='MISUNFLAGS' then
        begin
        result:=Rmisunflags;
        end
     else if N='DEFF' then
        begin
           Result:=Decnt;
        end
     else if N='TOTALEFF' then
        begin
           Result:=Decnt+Lecnt+Recnt;
        end
     else if N='TOTALGAMES' then
        begin
        Result:=0;
        case mode of
        0: Result:=beg_totalgames;
        1: Result:=int_totalgames;
        2: Result:=exp_totalgames;
        end;
        end
     else if N='OPENINGS' then
        begin
        result:=0;
           if (opt.doShow3BVafterGameStart)
              or(is_replay_mode)
              or(was_blasted)
              then
           begin
           Result:=openings;
           end;//case
        end
     else if N='ISLANDS' then
        begin
        result:=0;
           if (opt.doShow3BVafterGameStart)
              or(is_replay_mode)
              or(was_blasted)
              then
           begin
           Result:=bbbv_islands;
           end;//case
        end
     else if N='OPENINGSDONE' then
        begin
{        result:=0;
           if (opt.doShow3BVafterGameStart)
              or(is_replay_mode)
              or(was_blasted)
              then
           begin}
           Result:=done_openings;
         //  end;//case
        end
     else if N='FLAGSUSED' then
        begin
        result:=usedflags;
        end
	 else if N='LEVEL' then {0.47} {OBV support}
		begin
		result:=mode+1;
		end
	 else if N='OBV' then {0.47} {time to have obv}
		result:=obv
	 else if N='AVGOBV' then {0.47} {BAT support}
		begin
		case(mode) of
			modeBeg:result:=15;
			modeInt:result:=62.5;
			modeExp:result:=170;
			modeCus:result:=0;
		end
		end
     else if N='CELL0' then
        begin
           if (opt.doShow3BVafterGameStart)
              or(is_replay_mode)
              or(was_blasted)
              then
           begin
           Result:=cell0-3;
           end//case
           else result:=0;
        end
     else if N='CELL1' then
        begin
           if (opt.doShow3BVafterGameStart)
              or(is_replay_mode)
              or(was_blasted)
              then
           begin
           Result:=cell1-5;
           end//case
           else result:=0;
        end
     else if N='CELL2' then
        begin
           if (opt.doShow3BVafterGameStart)
              or(is_replay_mode)
              or(was_blasted)
              then
           begin
           Result:=cell2-7;
           end//case
           else result:=0;
        end
     else if N='CELL3' then
        begin
           if (opt.doShow3BVafterGameStart)
              or(is_replay_mode)
              or(was_blasted)
              then
           begin
           Result:=cell3-11;
           end//case
           else result:=0;
        end
     else if N='CELL4' then
        begin
           if (opt.doShow3BVafterGameStart)
              or(is_replay_mode)
              or(was_blasted)
              then
           begin
           Result:=cell4-13;
           end//case
           else result:=0;
        end
     else if N='CELL5' then
        begin
           if (opt.doShow3BVafterGameStart)
              or(is_replay_mode)
              or(was_blasted)
              then
           begin
           Result:=cell5-17;
           end//case
           else result:=0;
        end
     else if N='CELL6' then
        begin
           if (opt.doShow3BVafterGameStart)
              or(is_replay_mode)
              or(was_blasted)
              then
           begin
           Result:=cell6-19;
           end//case
           else result:=0;
        end
     else if N='CELL7' then
        begin
           if (opt.doShow3BVafterGameStart)
              or(is_replay_mode)
              or(was_blasted)
              then
           begin
           Result:=cell7-23;
           end//case
           else result:=0;
        end
     else if N='CELL8' then
        begin
           if (opt.doShow3BVafterGameStart)
              or(is_replay_mode)
              or(was_blasted)
              then
           begin
           Result:=cell8-29;
           end//case
           else result:=0;
        end
     else if N='DONECELL0' then
        begin
           Result:=cell0done;
        end
     else if N='DONECELL1' then
        begin
           Result:=cell1done;
        end
     else if N='DONECELL2' then
        begin
           Result:=cell2done;
        end
     else if N='DONECELL3' then
        begin
           Result:=cell3done;
        end
     else if N='DONECELL4' then
        begin
           Result:=cell4done;
        end
     else if N='DONECELL5' then
        begin
           Result:=cell5done;
        end
     else if N='DONECELL6' then
        begin
           Result:=cell6done;
        end
     else if N='DONECELL7' then
        begin
           Result:=cell7done;
        end
     else if N='DONECELL8' then
        begin
           Result:=cell8done;
        end
     else if N='MINES' then
        begin
           Result:=MC;
        end
     else if N='DX' then
        begin
           Result:=DX+1;
        end
     else if N='DY' then
        begin
           Result:=DY+1;
        end
     else if N='MODE' then
        begin
        case mode of
            0:result:=1;
            1:result:=2;
            2:result:=3;
        else result:=0;
        end;
        end

//     else if N='FORCED' then
//        begin
//        Result:=Frced;
//        end

     else if N='PATH' then
        begin
//        Result:=trunc((mpathx+mpathy)*sqrt2);
        result:=trunc(mpath);
        end

{     else if N='DEBUG' then
        begin
        if debug_form_created then Result:=debug.dm.lines.count-1
        else result:=0;
        end}
     else if N='RANKTIME' then
        begin
        result:=0;
           if //(was_blasted)or
              (iswin)
              then
           begin
			result:=1;
			tmp:=0;
			while (hist[tmp].dateDay<>0)and(tmp<cHistMax)do
			   begin
			   if hist[tmp].mode=mode then if hist[tmp].fstyle=(Rcnt>0) then
				  begin
				  if (gTime.S>hist[tmp].gameTimeS)
				  or
					 ((gTime.S=hist[tmp].gameTimeS)and(gTime.H>hist[tmp].gameTimeH))
					 then
						result:=result+1;
				  end;
			   tmp:=tmp+1;
			   end;
           end;//case
        end

     else if N='GLRANKTIME' then
        begin
        result:=0;
           if //(was_blasted)or
              (iswin)
              then
           begin
result:=1;
tmp:=0;
while (hist[tmp].dateDay<>0)and(tmp<cHistMax)do
   begin
   if hist[tmp].mode=mode then 
      begin
      if (gTime.S>hist[tmp].gameTimeS)
      or
         ((gTime.S=hist[tmp].gameTimeS)and(gTime.H>hist[tmp].gameTimeH))
         then
            result:=result+1;
      end;
   tmp:=tmp+1;
   end;
           end;//case
        end

     else if N='RANKBBBVS' then
        begin
        result:=0;
           if //(was_blasted)or
              (iswin)
              then
           begin
result:=1;
tmp:=0;
if (gTime.S+gTime.H/100)<>0 then
begin
tmpS:=trunc(bbbv/(gTime.S+gTime.H/100));
tmpH:=trunc(100*frac(bbbv/(gTime.S+gTime.H/100)));
end else begin
tmpS:=999;tmpH:=99;end;

while (hist[tmp].dateDay<>0)and(tmp<cHistMax)do
   begin
   if hist[tmp].mode=mode then if hist[tmp].fstyle=(Rcnt>0) then
      begin
      if (tmpS<hist[tmp].bbbvsS)or
         ((tmpS=hist[tmp].bbbvsS)and(tmpH<hist[tmp].bbbvsH))then
              result:=result+1;
      end;
   tmp:=tmp+1;
   end;
if result=0 then result:=1;
           end;//case
        end

     else if N='GLRANKBBBVS' then
        begin
        result:=0;
           if //(was_blasted)or
              (iswin)
              then
           begin
result:=1;
tmp:=0;
if (gTime.S+gTime.H/100)<>0 then
begin
tmpS:=trunc(bbbv/(gTime.S+gTime.H/100));
tmpH:=trunc(100*frac(bbbv/(gTime.S+gTime.H/100)));
end else begin
tmpS:=999;tmpH:=99;end;

while (hist[tmp].dateDay<>0)and(tmp<cHistMax)do
   begin
   if hist[tmp].mode=mode then// if hist[tmp].fstyle=(Rcnt>0) then
      begin
      if (tmpS<hist[tmp].bbbvsS)or
         ((tmpS=hist[tmp].bbbvsS)and(tmpH<hist[tmp].bbbvsH))then
              result:=result+1;
      end;
   tmp:=tmp+1;
   end;
if result=0 then result:=1;
           end;//case
        end

     else if N='RANKRQP' then
        begin
        result:=0;
           if //(was_blasted)or
              (iswin)
              then
           begin
result:=1;

if (bbbv<>0)and(gTime.s+gTime.h<>0)then
             trqp:=(gTime.s+1+gTime.h/100)/(bbbv/(gTime.s+gTime.h/100))
                   else trqp:=999;
tmp:=0;

while (hist[tmp].dateDay<>0)and(tmp<cHistMax)do
   begin
   if hist[tmp].mode=mode then if hist[tmp].fstyle=(Rcnt>0) then
      begin
      if trqp>=hist[tmp].rqp then
              result:=result+1;
      end;
   tmp:=tmp+1;
   end;
if result=0 then result:=1;
           end;//case
        end

     else if N='GLRANKRQP' then
        begin
        result:=0;
           if //(was_blasted)or
              (iswin)
              then
           begin
result:=1;

if (bbbv<>0)and(gTime.s+gTime.h<>0)then
             trqp:=(gTime.s+1+gTime.h/100)/(bbbv/(gTime.s+gTime.h/100))
                   else trqp:=999;
tmp:=0;

while (hist[tmp].dateDay<>0)and(tmp<cHistMax)do
   begin
   if hist[tmp].mode=mode then
      begin
      if trqp>=hist[tmp].rqp then
              result:=result+1;
      end;
   tmp:=tmp+1;
   end;
if result=0 then result:=1;
           end;//case
        end

     else if N='RANKIOS' then
        begin
        result:=0;
        if mode>0 then
     begin
           if //(was_blasted)or
              (iswin)
              then
           begin
result:=1;

           if (gTime.s>8)then
           trqp:=logN(gTime.s+gTime.h/100,bbbv)
              else trqp:=0;

tmp:=0;

while (hist[tmp].dateDay<>0)and(tmp<cHistMax)do
   begin
   if hist[tmp].mode=mode then if hist[tmp].fstyle=(Rcnt>0) then
      begin
      if trqp<=hist[tmp].ios then
              result:=result+1;
      end;
   tmp:=tmp+1;
   end;
if result=0 then result:=1;
           end;//case
end;
        end

     else if N='GLRANKIOS' then
        begin
        result:=0;
        if mode>0 then
     begin
           if //(was_blasted)or
              (iswin)
              then
           begin
result:=1;

           if (gTime.s>8)then
           trqp:=logN(gTime.s+gTime.h/100,bbbv)
              else trqp:=0;

tmp:=0;

while (hist[tmp].dateDay<>0)and(tmp<cHistMax)do
   begin
   if hist[tmp].mode=mode then
         begin
      if trqp<=hist[tmp].ios then
              result:=result+1;
      end;
   tmp:=tmp+1;
   end;
if result=0 then result:=1;
           end;//case
end;
        end

     else if N='RPI' then
        begin
        result:=0;
           if //(was_blasted)or
              (iswin)
              then
           begin
tmp2:=1;//time rank now
tmp:=0;
while (hist[tmp].dateDay<>0)and(tmp<cHistMax)do
   begin
   if hist[tmp].mode=mode then if hist[tmp].fstyle=(Rcnt>0) then
      begin
      if (gTime.S>hist[tmp].gameTimeS)
      or
         ((gTime.S=hist[tmp].gameTimeS)and(gTime.H>hist[tmp].gameTimeH))
         then
            tmp2:=tmp2+1;
      end;
   tmp:=tmp+1;
   end;
tmp3:=1;
tmp:=0;
if (gTime.S+gTime.H/100)<>0 then
begin
tmpS:=trunc(bbbv/(gTime.S+gTime.H/100));
tmpH:=trunc(100*frac(bbbv/(gTime.S+gTime.H/100)));
end else begin
tmpS:=999;tmpH:=99;end;

while (hist[tmp].dateDay<>0)and(tmp<cHistMax)do
   begin
   if hist[tmp].mode=mode then if hist[tmp].fstyle=(Rcnt>0) then
      begin
      if (tmpS<hist[tmp].bbbvsS)or
         ((tmpS=hist[tmp].bbbvsS)and(tmpH<hist[tmp].bbbvsH))then
              tmp3:=tmp3+1;
      end;
   tmp:=tmp+1;
   end;
if tmp3=0 then tmp3:=1;
// 50*(2+TOTALGAMES+TOTALGAMES-RANKTIME-RANKBBBVS)/TOTALGAMES
        tmpS:=0;
        case mode of
        0: tmpS:=beg_totalgames;
        1: tmpS:=int_totalgames;
        2: tmpS:=exp_totalgames;
        end;
if tmpS>0 then result:=50*(2+tmpS+tmpS-tmp2-tmp3)/tmpS else result:=0;
           end;//case
        end

     else if N='GLOBRPI' then
        begin
        result:=0;
           if //(was_blasted)
              //or
              (iswin)
              then
           begin
tmp2:=1;//time rank now
tmp:=0;
while (hist[tmp].dateDay<>0)and(tmp<cHistMax)do
   begin
   if hist[tmp].mode=mode then// if hist[tmp].fstyle=(Rcnt>0) then
      begin
      if (gTime.S>hist[tmp].gameTimeS)
      or
         ((gTime.S=hist[tmp].gameTimeS)and(gTime.H>hist[tmp].gameTimeH))
         then
            tmp2:=tmp2+1;
      end;
   tmp:=tmp+1;
   end;
tmp3:=1;
tmp:=0;
if (gTime.S+gTime.H/100)<>0 then
begin
tmpS:=trunc(bbbv/(gTime.S+gTime.H/100));
tmpH:=trunc(100*frac(bbbv/(gTime.S+gTime.H/100)));
end else begin
tmpS:=999;tmpH:=99;end;

while (hist[tmp].dateDay<>0)and(tmp<cHistMax)do
   begin
   if hist[tmp].mode=mode then //if hist[tmp].fstyle=(Rcnt>0) then
      begin
      if (tmpS<hist[tmp].bbbvsS)or
         ((tmpS=hist[tmp].bbbvsS)and(tmpH<hist[tmp].bbbvsH))then
              tmp3:=tmp3+1;
      end;
   tmp:=tmp+1;
   end;
if tmp3=0 then tmp3:=1;
// 50*(2+TOTALGAMES+TOTALGAMES-RANKTIME-RANKBBBVS)/TOTALGAMES
        tmpS:=0;
        case mode of
        0: tmpS:=beg_totalgames;
        1: tmpS:=int_totalgames;
        2: tmpS:=exp_totalgames;
        end;

result:=50*(2+tmpS+tmpS-tmp2-tmp3)/tmpS;
           end;//case
        end

     ELSE

                      begin
                      result:=0;
                      if debug_show_math_module_errors then
                      debug_add('#counters_formula_error: invalid operator '+N);
                      raised:=true;
                      exit;
                      end;

end;
{---------------------------------------------------------------------}
function CalcStr;
var P:Integer;
begin
//if raized then begin result:=0;
//   debug_add('#counters_formula_error handled: closing stack');exit;end;
raised:=false;

P:=1;
CalcStr:=Expr(S+' ',P,0)
end;

initialization
FillChar(Variables,SizeOf(Variables),0);   //   nullification

end.