unit Fcustom_board_size;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Spin, ExtCtrls, Menus, FileCtrl;

type
  Tcustom_board_size = class(TForm)
    lWidth: TLabel;
    lHeight: TLabel;
    lMines: TLabel;
    r1: TRadioButton;
    r2: TRadioButton;
    r3: TRadioButton;
    lDef: TLabel;
    Bevel1: TBevel;
    Bevel2: TBevel;
    edWidth: TSpinEdit;
    edHeight: TSpinEdit;
    edMines: TSpinEdit;
    bCancel: TButton;
    bApply: TButton;
    MainMenu1: TMainMenu;
    ExitBtn: TMenuItem;
    lPercents: TLabel;
    bSave: TButton;
    bLoad: TButton;
    flb: TFileListBox;
    bDelete: TButton;
    procedure bApplyClick(Sender: TObject);
    procedure r1Click(Sender: TObject);
    procedure r2Click(Sender: TObject);
    procedure r3Click(Sender: TObject);
    procedure edWidthChange(Sender: TObject);
    procedure edMinesChange(Sender: TObject);
    procedure bCancelClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure ExitBtnClick(Sender: TObject);
    procedure bSaveClick(Sender: TObject);
    procedure bLoadClick(Sender: TObject);
    procedure bDeleteClick(Sender: TObject);
    procedure flbDblClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  custom_board_size: Tcustom_board_size;

implementation

uses FMain, FData, FFunc,FCap;

{$R *.DFM}

procedure Tcustom_board_size.bApplyClick(Sender: TObject);
var s:String;
begin

if (edWidth.value<8)or(edWidth.value>30)then begin
showerror(cap_wrong_w_interval);exit;end;
if (edHeight.value<8)or(edHeight.value>30)then begin
showerror(cap_wrong_h_interval);exit;end;
if (edMines.value<1)or(edMines.value>trunc(edWidth.value*edHeight.value*0.99))
then begin
showerror(cap_wrong_m_interval);exit;end;

if not opt.doProhibitMultInstances then
application.Title:=projectname+' '
else application.Title:=projectname;
main.caption:=application.title;

dx:=edWidth.value-1;
dY:=edHeight.value-1;
MC:=edMines.value;

//timer_stop;
main.timer.Enabled:=false;
//main.thousandthtimer.enabled:=false;
main.timer.interval:=10;
checksum_all_store;

{if not opt.doZeroTimer then settime(1,0) else settime(0,0);}
settime(0,0);	{0.47} {we're going realtime}

board_loaded:=false;
board_uncovered:=false;

uid:='';
Lcnt:=0;
Rcnt:=0;
Dcnt:=0;
Lecnt:=0;
Recnt:=0;
Decnt:=0;
Done:=0;
usedflags:=0;
done_openings:=0;
cell0done:=0;
cell1done:=0;
cell2done:=0;
cell3done:=0;
cell4done:=0;
cell5done:=0;
cell6done:=0;
cell7done:=0;
cell8done:=0;
//mpathx:=0;mpathy:=0;
mpath:=0;
lb_down:=false;
rb_down:=false;
rreleased:=false;
mb_down:=false;
//mut_style:=(mut_style+1)mod 2;
set_all_up;

is_new_game:=true;
is_replay_mode:=false;//!!!!!!
is_preview_mode:=false;
progressbar_hide;
main.cur.Hide;

was_blasted:=false;
generate_cell_values;


clear_matrix;
clear_replay;
checksum_all_store;
checksum_board_store;


if (dx=7)and(dy=7)and(MC=10) then begin
main.Enabled:=true;main.show;hide;
main.BeginnerBtn.Click;exit;end;
if (dx=15)and(dy=15)and(MC=40) then begin
main.Enabled:=true;main.show;hide;
main.IntermediateBtn.Click;exit;end;
if (dx=29)and(dy=15)and(MC=99) then begin
main.Enabled:=true;main.show;hide;
main.ExpertBtn.Click;exit;end;

mode:=modeCUS;

reload_user_interface;
main.box.Width:=mdx*z+z;
main.box.Height:=mdy*z+z;
//main.box.Canvas.Draw(0,0,main.iEmpty.Picture.Bitmap);//???????
hard_reload_image;
clear_counters;

debug_add(cap_custommode_accept);

main.Enabled:=true;
main.show;
hide;
   if mode=modeBEG then s:='beginner'else
   if mode=modeINT then s:='intermediate'else
   if mode=modeEXP then s:='expert'else
   if mode=modeCUS then s:='custom';
   debug_add('data clearance done for '+s+' board '+inttostr(dx+1)+
   'x'+inttostr(dy+1)+', '+inttostr(mc)+' mines');

if opt.doShowCounters then counters_show else counters_hide;
memory_log;
end;

procedure Tcustom_board_size.r1Click(Sender: TObject);
begin
edWidth.value:=8;
edHeight.value:=8;
edMines.value:=10;
end;

procedure Tcustom_board_size.r2Click(Sender: TObject);
begin
edWidth.value:=16;
edHeight.value:=16;
edMines.value:=40;
end;

procedure Tcustom_board_size.r3Click(Sender: TObject);
begin
edWidth.value:=30;
edHeight.value:=16;
edMines.value:=99;
end;

procedure Tcustom_board_size.edWidthChange(Sender: TObject);
var s:string;
begin
try edMines.MaxValue:=trunc(edWidth.value*edHeight.value*0.99);
try s:=inttostr(trunc(100000*custom_board_size.edMines.value/
   (custom_board_size.edHeight.value*custom_board_size.edWidth.value)))+' %';
   if length(s)<7 then while length(s)<7 do s:='0'+s;insert(',',s,3);
   custom_board_size.lpercents.Caption:=s;except
   custom_board_size.lpercents.Caption:='-';end;
except end;
end;

procedure Tcustom_board_size.edMinesChange(Sender: TObject);
var s:string;
begin
try
if edMines.value>trunc(edWidth.value*edHeight.value*0.99)
then edMines.value:=trunc(edWidth.value*edHeight.value*0.99);
try s:=inttostr(trunc(100000*custom_board_size.edMines.value/
   (custom_board_size.edHeight.value*custom_board_size.edWidth.value)))+' %';
   if length(s)<7 then while length(s)<7 do s:='0'+s;insert(',',s,3);
   custom_board_size.lpercents.Caption:=s;except
   custom_board_size.lpercents.Caption:='-';end;
except end;
end;

procedure Tcustom_board_size.bCancelClick(Sender: TObject);
begin
debug_add(cap_custommode_dismissed);
timer_stop;
main.Enabled:=true;
main.show;
custom_board_size.hide;
if opt.doShowCounters then counters_show else counters_hide;
end;

procedure Tcustom_board_size.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
abort;
//bCancel.click;
end;

procedure Tcustom_board_size.FormCreate(Sender: TObject);
var s:String;
begin
custom_board_size_form_created:=true;
//alwaysontop_apply;
//if opt.doAlwaysOnTop then custom_board_size.FormStyle:=fsStayonTop;
//language_apply;
custom_board_size.Caption:=cap_custom_board_size_caption;
custom_board_size.lWidth.Caption:=cap_lwidth;
custom_board_size.lHeight.Caption:=cap_lHeight;
custom_board_size.lMines.Caption:=cap_lMines;
try s:=inttostr(trunc(100000*custom_board_size.edMines.value/
   (custom_board_size.edHeight.value*custom_board_size.edWidth.value)))+' %';
   if length(s)<7 then while length(s)<7 do s:='0'+s;insert(',',s,3);
   custom_board_size.lpercents.Caption:=s;except
   custom_board_size.lpercents.Caption:='-';end;
custom_board_size.bCancel.Caption:=cap_bcancel;
custom_board_size.bApply.Caption:=cap_bApply;
custom_board_size.bsave.Caption:=cap_bSave;
custom_board_size.bLoad.Caption:=cap_bLoad;
custom_board_size.bDelete.Caption:=cap_bDelete;
custom_board_size.lDef.Caption:=cap_ldef;
custom_board_size.r1.Caption:=cap_r1;
custom_board_size.r2.Caption:=cap_r2;
custom_board_size.r3.Caption:=cap_r3;
end;

procedure Tcustom_board_size.ExitBtnClick(Sender: TObject);
begin
bCancel.click;
end;

procedure Tcustom_board_size.bSaveClick(Sender: TObject);
var f:textfile;s:string;
begin
if not DirectoryExists(opt.apppath+abp_folder) then
    if not CreateDir(opt.apppath+abp_folder) then begin
    debug_add('#'+cap_dir_not_saved);
    showerror(cap_dir_not_saved+#13#10+
           opt.apppath+abp_folder);exit;end;
try
s:=inttostr(edWidth.value)+'x'+inttostr(edHeight.value)+
   '-'+inttostr(edMines.value)+'mines_('+copy(lpercents.caption,1,6)+').abp';
assignfile(f,opt.apppath+abp_folder+s);
rewrite(f);
writeln(f,'Arbiter Custom Board Preset');
writeln(f,'version='+ver);
closefile(f);
custom_board_size.flb.Directory:=opt.apppath+abp_folder;
activecontrol:=bApply;
except
    debug_add('#'+cap_file_not_saved);
    showerror(cap_file_not_saved)end;
end;

procedure Tcustom_board_size.bLoadClick(Sender: TObject);
var s:string;
begin
try
if flb.FileName='' then begin
       debug_add('#'+cap_file_not_sel);
       showerror(cap_file_not_sel);exit;end;
s:=extractfilename(flb.FileName);
if (pos('X',uppercase(s))<2)or
   (pos('_(',uppercase(s))<11)or
   (pos('-',uppercase(s))<4)or
   (pos('MINES_(',uppercase(s))<6)then begin
         debug_add('#'+cap_file_not_loaded);
         showerror(cap_file_not_loaded);exit;end;
edwidth.Value:=strtoint(copy(s,1,pos('X',uppercase(s))-1));
delete(s,1,pos('X',uppercase(s)));
edHeight.Value:=strtoint(copy(s,1,pos('-',uppercase(s))-1));
delete(s,1,pos('-',uppercase(s)));
edMines.Value:=strtoint(copy(s,1,pos('MINES_(',uppercase(s))-1));
activecontrol:=bApply;
except
   debug_add('#'+cap_file_not_loaded);showerror(cap_file_not_loaded)end;
end;

procedure Tcustom_board_size.bDeleteClick(Sender: TObject);
begin
if flb.FileName='' then begin showerror(cap_file_not_sel);exit;end;

{if MessageDlg(cap_del_file+' ?'#13#10#13#10+flb.filename,
    mtConfirmation, [mbYes, mbNo], 0) = mrYes then}

try deletefile(flb.filename);
try
if not DirectoryExists(opt.apppath+abp_folder) then
    if not CreateDir(opt.apppath+abp_folder) then begin
      debug_add('#'+cap_dir_not_saved);
      showerror(cap_dir_not_saved+#13#10+opt.apppath+abp_folder);end;
custom_board_size.flb.Directory:=opt.apppath+abp_folder;
except debug_add('#'+cap_dir_not_loaded);showerror(cap_dir_not_loaded);exit;end;

except end;
end;

procedure Tcustom_board_size.flbDblClick(Sender: TObject);
begin
bload.click;
end;

end.
