unit Fdebug;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, StdCtrls, ExtCtrls;

type
  Tdebug = class(TForm)
    MainMenu1: TMainMenu;
    ClearBtn: TMenuItem;
    SaveAsBtn: TMenuItem;
    CloseBtn: TMenuItem;
    dm: TMemo;
    sd: TSaveDialog;
    FontBtn: TMenuItem;
    fd: TFontDialog;
    CommandBtn: TMenuItem;
    Bevel1: TBevel;
    FindDialog1: TFindDialog;
    procedure CloseBtnClick(Sender: TObject);
    procedure dmMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure dmContextPopup(Sender: TObject; MousePos: TPoint;
      var Handled: Boolean);
    procedure dmKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ClearBtnClick(Sender: TObject);
    procedure SaveAsBtnClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FontBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure dmChange(Sender: TObject);
    procedure CommandBtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  debug: Tdebug;


implementation

uses FMain,FFunc,FData, Fdebug_command,FCap;

{$R *.DFM}

procedure Tdebug.CloseBtnClick(Sender: TObject);
begin
timer_stop;
main.Enabled:=true;
main.show;
main.newbtn.click;
debug.hide;
if opt.doShowCounters then counters_show else counters_hide;
end;

procedure Tdebug.dmMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
activecontrol:=nil;abort;
end;

procedure Tdebug.dmContextPopup(Sender: TObject; MousePos: TPoint;
  var Handled: Boolean);
begin
activecontrol:=nil;abort;
end;

procedure Tdebug.dmKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
activecontrol:=nil;abort;
end;

procedure Tdebug.ClearBtnClick(Sender: TObject);
begin
dm.Clear;
debug_add(cap_debug_cleared)
end;

procedure Tdebug.SaveAsBtnClick(Sender: TObject);
var s1:String;
begin
if dm.Text='' then exit;
init_timer;
s1:='_Debug_MS_Arbiter_';
if ts.wHour<10 then s1:=s1+'0';
s1:=s1+inttostr(ts.wHour)+'h';
if ts.wMinute<10 then s1:=s1+'0';
s1:=s1+inttostr(ts.wMinute)+'m_';
if ts.wDay<10 then s1:=s1+'0';
s1:=s1+inttostr(ts.wDay)+'d';
if ts.wMonth<10 then s1:=s1+'0';
s1:=s1+inttostr(ts.wMonth)+'m';
s1:=s1+inttostr(ts.wYear)+'y.txt';
sd.FileName:=s1;
sd.InitialDir:=opt.AppPath;
if sd.execute then
try
dm.lines.SaveToFile(sd.filename);
sd.FileName:='';
debug_add(cap_debug_saveok);
except debug_add(cap_debug_save_error);end;
end;

procedure Tdebug.FormClose(Sender: TObject; var Action: TCloseAction);
begin
main.Enabled:=true;
main.show;
if opt.doShowCounters then counters_show;//hide no sense
debug.hide;
end;

procedure Tdebug.FontBtnClick(Sender: TObject);
begin
if fd.execute then dm.font:=fd.font;
end;

procedure Tdebug.FormCreate(Sender: TObject);
var osver:tosversioninfo;
    platformstr:String;
    meminfo:tmemorystatus;
    keybl:array[0..100] of char;
begin
try
debug_form_created:=true;
width:=640;
height:=480;
//language_apply;
debug.Caption:=cap_debug_caption;
debug.ClearBtn.Caption:=cap_debug_clearbtn;
debug.SaveAsBtn.Caption:=cap_debug_saveasbtn;
debug.FontBtn.Caption:=cap_debug_fontbtn;
debug.CommandBtn.Caption:=cap_debug_commandbtn;
debug.CloseBtn.Caption:=cap_debug_closebtn;
init_timer;
debug_add('path      | '+opt.apppath);
debug_add('date      | '+getDefaultreplayName('<DDD>, <DD>.<MM>.<YYYY>,')+
' process 0x'+inttohex(application.handle,8)+' launched');
debug_add('cpu speed | run the command get_cpu_speed');

meminfo.dwLength:=sizeof(meminfo);
globalmemorystatus(meminfo);
memused:=meminfo.dwAvailPhys;
memused_min:=ts.wMinute;
memused_hour:=ts.wHour;
debug_add('memory    | '+inttostr(memused div 1048576)+
  ','+inttostr((meminfo.dwAvailPhys div 104857)mod 10)+' of '+
      inttostr(meminfo.dwTotalPhys div 1048576)+
  ','+inttostr((meminfo.dwTotalPhys div 104857)mod 10)+' MB RAM free');
//#######debug_add('disk space: free '+inttostr(diskfree(0) div 1048576)+' MB');

osver.dwOSVersionInfoSize:=SizeOf(osver);
if GetVersionEx(osver) then
   begin
   case osver.dwPlatformId of
   ver_platform_win32s:platformstr:='Windows 3.1';
   ver_platform_win32_windows:platformstr:='Windows 95/98/Me';
   ver_platform_win32_nt:platformstr:='Windows NT';
   else platformstr:='Unknown';end;
   debug_add(format('platform  | '+platformstr+' %d.%d build %d, %s',[osver.dwMajorVersion,OSVer.dwMinorVersion,(osver.dwBuildnumber and $FFFF),osver.szCSDVersion]));
   end;

if tz.Bias<0 then begin
if (tz.Bias mod 60)<10 then
debug_add('timezone  | '+tz.StandardName+
   ' (GMT +'+inttostr(abs(tz.Bias div 60))+':'+
   inttostr(tz.Bias mod 60)+'0)')
else debug_add('timezone  | '+tz.StandardName+
'GMT +'+inttostr(abs(tz.Bias div 60))+':'+
   inttostr(tz.Bias mod 60)+')')
end else begin
if (tz.Bias mod 60)<10 then
debug_add('timezone  | '+tz.StandardName+
   ' (GMT -'+inttostr(abs(tz.Bias div 60))+':'+
   inttostr(tz.Bias mod 60)+'0)')
else debug_add('timezone  | '+tz.StandardName+
   'GMT -'+inttostr(abs(tz.Bias div 60))+':'+
   inttostr(tz.Bias mod 60)+')')
end;

GetKeyboardLayoutName(keybl);
//debug_add('language: '+{main.si.DefaultLanguageString}'default');
debug_add('language  | '+keybl);

debug_add('---');
debug_add('encrypt_engine testing ...');
checksum_board_store;
checksum_board_read;
checksum_opt_store;
checksum_opt_read;
checksum_all_store;
checksum_all_read;
debug_add('encrypt_engine test ok');
debug_add('warp field stabilized. opening gate to the minesweeper world');
debug_add('---');
debug_add('who of them got the skills to test me?');
debug_add('---');
if debugmode then
   begin
   debug_add('run debug mode. debug protocol saved.');
   debug_silent_save;
   end;
except
showerror('Unable to scan system parameters.');
debug_add('unable to scan system parameters');
end;
end;

procedure Tdebug.dmChange(Sender: TObject);
begin
if dm.Lines.Count>3000 then begin
dm.clear;
debug_add('debug log automated clearance done');end;
try debug.Caption:=cap_debug_caption+' * ['+inttostr(debug.dm.lines.count)+' lines / '+inttostr(length(debug.dm.text))+' bytes / '+
   inttostr(trunc(100-debug.dm.lines.count/30))+'% free]';except end;
end;

procedure Tdebug.CommandBtnClick(Sender: TObject);
begin
debug_command.Left:=trunc(debug.left+debug.Width/2-debug_command.width/2);
debug_command.top:=trunc(debug.top+debug.height/2-debug_command.height/2);
{debug.Left:=0;debug.top:=0;}

if debug_command.Left<0 then debug_command.left:=0;
if debug_command.Left>screen.width-debug_command.width then
   debug_command.Left:=screen.width-debug_command.width;
if debug_command.top<0 then debug_command.top:=0;
if debug_command.top>screen.height-debug_command.height then
   debug_command.top:=screen.height-debug_command.height;

debug_command.ActiveControl:=debug_command.dc;
debug_command.show;
debug.Enabled:=false;
end;

end.
